-- name: HL1 Crowbar

if not is_game_single_player then return end

frame_countdown = 0

local function bhv_weapon_init(o)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    obj_scale(o, 0.004)
end

local function bhv_weapon_loop(o)
    o.oPosX = gLakituState.pos.x
    o.oPosY = gLakituState.pos.y
    o.oPosZ = gLakituState.pos.z
    o.oFaceAngleYaw = gLakituState.yaw - 32768
    o.oFaceAnglePitch = calculate_pitch(gLakituState.pos, gLakituState.focus) * -0.85 + 512
end

function raycast_forward()
    local l = gLakituState
    local zoffset = 290

    local camrot = {
        x = -calculate_pitch(l.pos, l.goalFocus),
        y = calculate_yaw(l.pos, l.goalFocus),
        z = l.roll
    }

    local cursor = {
        x = 0,
        y = 0,
        z = zoffset
    }

    djui_hud_set_resolution(RESOLUTION_N64)
    vec3f_rotate_zxy(cursor, camrot)
    vec3f_mul(cursor, 30)
    local ray = collision_find_surface_on_ray(l.pos.x, l.pos.y, l.pos.z, cursor.x, cursor.y, cursor.z)
    return ray
end

local function update()
    if frame_countdown ~= 0 then
        frame_countdown = frame_countdown - 1
    end
end

id_bhvWeapon = hook_behavior(nil, OBJ_LIST_GENACTOR, true, bhv_weapon_init, bhv_weapon_loop)
hook_event(HOOK_UPDATE, update)